'****************************************************************
'*  Name    : default.bas                                       *
'*  Author  : B. van Schie                                      *
'*  Notice  : Copyright (c) 2007     ||    060931BAUG07         *
'*          : All Rights Reserved                               *
'*  Date    : 6-8-2007                                          *
'*  Version : 1.1                                               *
'*  Notes   : Et Toto - "Allesomvattend"                        *
'*          : Backlight dimmer                                  *
'****************************************************************
Device 16F628A                ;Gebruik een 16F628A type
CONFIG WDT_OFF, PWRTE_ON, LVP_OFF, MCLRE_OFF, HS_OSC ;INTRC_OSC_NOCLKOUT verwijderd
ALL_DIGITAL TRUE              ;Alle ingangen digitaal

declare XTAL 4          
declare LCD_RSPIN PORTB.0      ;RS pin declareren

        ;76543210              
TRISA = %11111110              ;i/o portA
TRISB = %11110111              ;i/o portB

print $FE,$40,$0E,$0A,$0E,$00,$00,$00,$00,$00

symbol schakelaar = PORTA.1        
Symbol dq = PORTA.2   ; inlees poort ds1820
DIM Temp AS WORD              ' Holds the temperature value 
DIM C AS BYTE                 ' Holds the counts remaining value 
DIM CPerD AS BYTE             ' Holds the Counts per degree C value   
Dim backlight0 as Byte         ;Variabele instellen
dim teller as byte

delayms 500 ;lcd stabalyse

clear

start:                 
backlight0 = eread 0            ;Eeprom backlight waarde opvragen
hpwm 1, backlight0, 2000

While 1 = 1
  print at 1,1, "Temperatuur :: "
  
  OWRITE DQ, 1, [$CC, $44]      ' Send Calculate Temperature command 
  REPEAT 
  DELAYMS 1000                  ' Wait until conversion is complete 
  OREAD DQ, 4, [C]              ' Keep reading low pulses until
  UNTIL C <> 0                  ' the DS1820 is finished.
  OWRITE DQ, 1, [$CC, $BE]      ' Send Read ScratchPad command
  OREAD DQ, 2,[Temp.LOWBYTE,Temp.HIGHBYTE, C, C, C, C, C, CPerD]
  ' Calculate the temperature in degrees Centigrade
  Temp = (((Temp >> 1) * 100) - 25) + (((CPerD - C) * 100) / CPerD)
  print at 2,5, DEC Temp / 100, ".", DEC2 Temp, 0, "C "
  for teller = 0 to 40
    if schakelaar = 0 then
      delayms 150
      goto honderd
    endif
    delayms 100
    inc teller
  next
  teller = 0    
Wend

honderd:        
cls
print at 1,1, "BL-Selecteren"
print at 2,1, "   100%"
hpwm 1, 255, 2000
  
while 1 = 1
  if schakelaar = 0 then
    delayms 150
    if schakelaar = 0 then
      backlight0 = 255
      delayms 1900
      goto memory
    else
      goto zesenzestig
    endif
  endif
wend

zesenzestig:          
cls
print at 1,1, "BL-Selecteren"  
print at 2,1, "   66%"
hpwm 1, 168, 2000
  
while 1 = 1         
  if schakelaar = 0 then  
    delayms 150
    if schakelaar = 0 then
      backlight0 = 168
      delayms 1900
      goto memory
    else
      goto drieendertig
    endif
  endif
wend

drieendertig:     
cls
print at 1,1, "BL-Selecteren"     
print at 2,1, "   33%"
hpwm 1, 84, 2000
  
while 1 = 1
  if schakelaar = 0 then   
    delayms 150 
    if schakelaar = 0 then
      backlight0 = 84
      delayms 1900
      goto memory
    else
      goto uit
    endif
  endif
wend

uit:       
cls
print at 1,1, "BL-Selecteren"   
print at 2,1, "   UIT"
hpwm 1, 0, 2000
 
while 1 = 1  
  if schakelaar = 0 then        
    delayms 150     
    if schakelaar = 0 then
      backlight0 = 0
      delayms 1900
      goto memory
    else
      goto honderd
    endif
  endif
wend

memory:
CLS
ewrite 0, [backlight0]           ;Eeprom geheugen schrijven
print at 1,1, "BL-Selecteren"
Print at 1,1, "     Opgeslagen!"
delayms 2500
CLS
goto start
